import ArticleActions from './ArticleActions';
import { Link } from 'react-router-dom';
import React from 'react';
import { TwitterShareButton } from "react-share";

const ArticleMeta = props => {
  const article = props.article;
  const link = `${window.location.href}`

  return (
    <div className="article-meta" >
      <Link to={`/@${article.author.username}`}>
        <img src={article.author.image} alt={article.author.username} 
        onError={e => { e.currentTarget.src = "https://static.productionready.io/images/smiley-cyrus.jpg"; }}/>
      </Link>

      <div className="info">
        <Link to={`/@${article.author.username}`} className="author">
          {article.author.username}
        </Link>
        <span className="date">
          {new Date(article.createdAt).toLocaleString()}
        </span>
      </div>
      <ArticleActions canModify={props.canModify} article={article}/>
      <TwitterShareButton url={link}  style={{alignItems: 'right'}}>
        {<a class="twitter-share-button" data-show-count="false" target="_blank" style={{margin: 10}}>
        <i className="ion-social-twitter"></i>Tweet</a>}
      </TwitterShareButton>
    </div>
  );
};

export default ArticleMeta;
