import React from 'react';
import agent from '../../agent';
import { connect } from 'react-redux';
import { ADD_COMMENT } from '../../constants/actionTypes';
import BadWords from '../Badwords';

const mapDispatchToProps = dispatch => ({
  onSubmit: payload =>
    dispatch({ type: ADD_COMMENT, payload })
});

class CommentInput extends React.Component {
  constructor() {
    super();
    this.state = {
      body: ''
    };

    this.setBody = ev => {
      this.setState({ body: ev.target.value });
    };

    this.createComment = ev => {
      if (this.state.body < 1)  {
        ev.preventDefault()
        return null
      }
      ev.preventDefault();
      const payload = agent.Comments.create(this.props.slug,
        { body: this.state.body });
      this.setState({ body: '' });
      this.props.onSubmit(payload);
    };
  }

  render() {
    return (
      <form className="card comment-form" onSubmit={this.createComment}>
        <div className="card-block">
          <textarea className="form-control"
            placeholder="Write a comment..."
            maxlength="1000"
            value={this.state.body}
            onChange={this.setBody}
            rows="3"
            onKeyDown={(e) => {
              if (e.keyCode === 9) e.preventDefault();
            }}>
          </textarea>
        </div>
        
        <div className="card-footer">
          <img
            src={this.props.currentUser.image}
            className="comment-author-img-mylly"
            alt={this.props.currentUser.username}
            onError={e => { e.currentTarget.src = "https://static.productionready.io/images/smiley-cyrus.jpg"; }}/>
          <BadWords comment={this.state.body}/>  
          <button
            className="btn-primary-mylly"
            id="publish"
            type="submit">
            Post Comment
          </button>
        </div>
      </form>
    );
  }
}

export default connect(() => ({}), mapDispatchToProps)(CommentInput);
